#!/usr/bin/python
import sys

from charmhelpers.core.hookenv import (
    Hooks,
    config,
    log,
    UnregisteredHookError,
)
from charmhelpers.core.host import (
    #restart_on_change,
    #service_restart,
    service_start,
    service_stop,
)

from charmhelpers.fetch import (
    add_source,
    apt_install,
    apt_update,
    #filter_installed_packages,
)

from charmhelpers.payload.execd import execd_preinstall
#from charmhelpers.contrib.charmsupport import nrpe

from grafana_utils import (
    determine_packages,
    #juju_log,
    #restart_map,
    write_conf,
)

hooks = Hooks()


@hooks.hook()
def install():
    execd_preinstall()
    add_source(config('source'), '7AD95B3F')
    apt_update()
    apt_install(determine_packages(), fatal=True)
    write_conf()


@hooks.hook('start')
def start():
    service_start('grafana-server')


@hooks.hook('stop')
def stop():
    service_stop('grafana-server')


@hooks.hook('config-changed', 'upgrade-charm')
def upgrade_charm():
    write_conf()


def main():
    try:
        hooks.execute(sys.argv)
    except UnregisteredHookError as e:
        log('Unknown hook {} - skipping.'.format(e))


if __name__ == '__main__':
    main()
