from mock import (
    MagicMock,
    #patch,
    #call
)

import grafana_utils as utils
from test_utils import (
    CharmTestCase,
    RESTART_MAP
)

# Need to do some early patching to get the module loaded.
_restart_map = utils.restart_map
_write_conf = utils.write_conf

utils.restart_map = MagicMock()
utils.restart_map.return_value = RESTART_MAP
utils.write_conf = MagicMock()

import grafana_hooks as hooks
hooks.hooks._config_save = False

hooks.hooks._config_save = False

# Unpatch it now that its loaded.
utils.restart_map = _restart_map
utils.write_conf = _write_conf

TO_PATCH = [
    # fetch
    'add_source',
    'apt_install',
    'apt_update',
    # grafana_utils
    'determine_packages',
    'write_conf',
    # charmhelpers.core.hookenv
    'config',
    'log',
    # charmhelpers.core.host
    'service_start',
    'service_stop',
    'execd_preinstall',
]


class TestInstallHook(CharmTestCase):

    def setUp(self):
        super(TestInstallHook, self).setUp(hooks, TO_PATCH)
        self.config.side_effect = self.test_config.get_all

    def test_install_ppa_distro(self):
        'It redirects to cloud archive if setup to install trusty+distro'
        #self.lsb_release.return_value = {'DISTRIB_CODENAME': 'trusty'}
        hooks.hooks.execute(['hooks/install'])
        ca = 'deb https://packagecloud.io/grafana/stable/debian/ wheezy main'
        key = '7AD95B3F'
        self.add_source.assert_called_with(ca, key)

    def test_correct_install_packages(self):
        'It installs the correct packages based on what is determined'
        self.determine_packages.return_value = ['grafana']
        hooks.hooks.execute(['hooks/install'])
        self.apt_install.assert_called_with(['grafana'], fatal=True)
