#from mock import patch, call, MagicMock

from collections import OrderedDict
import os

os.environ['JUJU_UNIT_NAME'] = 'grafana'
import grafana_utils

from test_utils import (
    CharmTestCase,
)

TO_PATCH = [
    # helpers.core.hookenv
    'log',
]


DPKG_OPTIONS = [
    '--option', 'Dpkg::Options::=--force-confnew',
    '--option', 'Dpkg::Options::=--force-confdef',
]


class TestGrafanaUtils(CharmTestCase):

    def setUp(self):
        super(TestGrafanaUtils, self).setUp(grafana_utils, TO_PATCH)
        #self.config.side_effect = self.test_config.get_all

    def test_creates_restart_map_all_enabled(self):
        'It creates correct restart map when all services enabled'
        ex_map = OrderedDict([
            ('/etc/grafana/grafana.ini', ['grafana-server']),
        ])
        self.assertEquals(grafana_utils.restart_map(), ex_map)

    def test_list_services(self):
        'It returns a list of services associate with this charm'
        ex_list = ['grafana-server']
        self.assertEquals(grafana_utils.services(), ex_list)
